<template>
<div class="box">
  <st-modal
    :dialog="dialog"
    titulo="Registro exitoso"
    texto="Se le ha enviado un correo para finalizar el registro."
    @click="dialog=false"
  />
  <!-- LOGIN FORM -->
  <v-form
    v-show="mode==='login'"
    ref="form"
    v-model="valid"
  >
    <st-title text="LOGIN"/>
    <div class="fields">
      <v-text-field
        v-for="(field, index) in fields"
        v-model="field.value"
        :rules="field.rules"
        :label="field.label"
        :type="field.type"
        :key="index"
        required
      />
      <div class="caption cursor text-right text--secondary">¿Olvidaste tu contraseña?</div>
    </div>
    <v-btn large block color="primary" class="my-2 text-capitalize" :loading="loading" @click="login">
      Iniciar Sesión
    </v-btn>
    <v-btn large block outlined color="#DF4A38" class="my-2" style="text-transform:none" :loading="googleLoading" @click="loginWithGoogle">
      <v-icon left>fab fa-google</v-icon> Iniciar Sesión con Google
    </v-btn>
    <div class="caption cursor text--secondary mt-5 text-center" @click="changeModeRegister">
      ¿No tienes una cuenta? <span ><b>Regístrate</b></span>
    </div>
    <!--
    <st-primary-btn class="block google" nombre="Iniciar Sesion con Google" @click="loginWithGoogle"/>
      <st-primary-btn class="block" :loading="loading" @click="login" nombre="Iniciar Sesion"/>
    <st-primary-btn class="block two" nombre="Registrarse" @click="changeModeRegister"/>-->
  </v-form>

  <!-- REGISTER FORM -->
  <v-form v-show="mode==='register'"  ref="form" v-model="valid">
    <st-title text="REGISTRO"/>
    <div class="fields">
      <v-text-field
        v-model="fields.email.value"
        :rules="fields.email.rules"
        :label="fields.email.label"
        :type="fields.email.type"
        required
      />
    </div>
    <v-btn large block color="primary" class="my-2 text-capitalize" :loading="loading" @click="register">
      Registrarse
    </v-btn>
     <v-btn large block outlined color="#DF4A38" class="my-2" style="text-transform:none" :loading="googleLoading" @click="loginWithGoogle">
      <v-icon left>fab fa-google</v-icon> Iniciar Sesión con Google
    </v-btn>
    <div class="caption cursor text--secondary mt-5 text-center" @click="changeModeLogin">
      ¿Ya tienes una cuenta? <span ><b>Ingresa</b></span>
    </div>
    <!--
    <st-primary-btn class="block" :loading="loading" @click="register" nombre="Registrarse"/>
    <st-primary-btn class="block google" nombre="Iniciar Sesion con Google" @click="loginWithGoogle"/>
    <st-primary-btn class="block two" nombre="Iniciar Sesion" @click="changeModeLogin"/>-->
  </v-form>
</div>
</template>

<script>
import { isValidEmail } from '../../assets/js/fields-validation';
import tokenTool from "../../assets/js/token-tool";
import Modal from "@/components/Modal"

export default {
  data () {
    return{
      dialog:false,
      valid:true,
      loading: false,
      googleLoading: false,
      mode: 'login',
      fields:{
        email:{
          value: '',
          label: 'Correo electrónico',
          type: 'text',
          rules: [
            v => !!v || 'El correo es requerido',
            v => isValidEmail(v) || 'Ingrese un correo válido'
          ],
        },
        password:{
          value: '',
          label: 'Contraseña',
          type: 'password',
          rules: [
            v => !!v || 'La contraseña es requerida',
          ],
        },
      }
    }
  },
  components: {
    'st-modal':Modal
  },
  methods: {
    async login(){
      this.$refs.form.validate()
      if (this.valid){
        this.loading = true
        try{
          let payload  = {email: this.fields.email.value, password: this.fields.password.value}
          let response = await this.$api.authenticateUser(payload)
          let token = response.data.data.token
          tokenTool.saveToken(token)
          let { data: { data } } = await this.$api.getRoles(this.fields.email.value)
          this.$store.dispatch('login', data)
          this.$router.push('/roles')
        }
        catch(e){
          console.error(e)
          this.$store.commit('setError', e)
        }
        this.loading = false
      }
    },
    async register() {
      this.$refs.form.validate();
      if (this.valid) {
        try {
          this.loading = true;
          let { data: { message } } = await this.$api.registerUser({correo: this.fields.email.value});
          this.dialog = true
          //this.$router.push('/')
        }
        catch(e) {
          console.error(e);
          this.$store.commit('setError', e);
        }
        this.loading = false;
      }
    },
    changeModeRegister() { this.mode = "register"; },
    changeModeLogin() { this.mode = "login"; },
    async loginWithGoogle(){
      let authCode = null
      try {
        authCode = await this.$gAuth.getAuthCode()
      } catch(e) {
        return
      }

      try{
        this.googleLoading = true
        const response = await this.$api.authenticateGoogleUser({ code: authCode })
        let token = response.data.data.token
        let email = response.data.data.email
        tokenTool.saveToken(token)
        let { data: { data } } = await this.$api.getRoles(email)
        this.$store.dispatch('login', data)
        this.$router.push('/roles')
      }
      catch(e){
        this.$store.commit('setError', e)
      }
      this.googleLoading = false
    }
  }
}
</script>

<style scoped lang="scss">
$height-fields:152px;
.box{
  border-radius:4px;
  padding:80px 50px;
  min-height:600px;
  width:400px;
}
.fields{
  margin-top:40px;
  margin-bottom:60px;
  min-height: $height-fields;
}
.cursor{
  cursor:pointer
}
</style>
